=== debian/changelog ===
opensubdiv (3.4.3-3) unstable; urgency=medium

  * debian/control: debhelper bump 12 -> 13

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 12 May 2020 20:14:00 +0200

opensubdiv (3.4.3-2) unstable; urgency=medium

  * debian/: fix breakage due to SONAME bump (Closes: #959118)

 -- Matteo F. Vescovi <mfv@debian.org>  Wed, 29 Apr 2020 22:55:54 +0200

opensubdiv (3.4.3-1) unstable; urgency=medium

  * New upstream release
  * debian/control: S-V bump 4.4.1 -> 4.5.0 (no changes needed)
  * debian/copyright: drop now-unused entries

 -- Matteo F. Vescovi <mfv@debian.org>  Tue, 28 Apr 2020 23:43:47 +0200
