=== debian/control ===
Source: opensubdiv
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Matteo F. Vescovi <mfv@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libtbb-dev,
 libglew-dev,
 libglfw3-dev,
 libxcursor-dev,
 libxi-dev,
 libxinerama-dev,
 libxrandr-dev,
 libxxf86vm-dev,
 opencl-headers,
 zlib1g-dev
Build-Depends-Indep:
 doxygen,
 ptex-base,
 python3-dev,
 python3-docutils,
 python3-pygments
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: http://graphics.pixar.com/opensubdiv/
Vcs-Git: https://salsa.debian.org/multimedia-team/opensubdiv.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/opensubdiv

Package: libosdcpu3.4.3
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces: libosdcpu3.4.0 (<< 3.4.3-2)
Breaks: libosdcpu3.4.0 (<< 3.4.3-2)
Description: high performance subdivision surface (subdiv) library - CPU runtime
 OpenSubdiv is a set of open source libraries that implement high
 performance subdivision surface (subdiv) evaluation on massively
 parallel CPU and GPU architectures. This codepath is optimized for
 drawing deforming subdivs with static topology at interactive
 framerates. The resulting limit surface matches Pixar's Renderman to
 numerical precision.
 .
 This package provides the CPU-based runtime library.

Package: libosdgpu3.4.3
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces: libosdgpu3.4.0 (<< 3.4.3-2)
Breaks: libosdgpu3.4.0 (<< 3.4.3-2)
Description: high performance subdivision surface (subdiv) library - GPU runtime
 OpenSubdiv is a set of open source libraries that implement high
 performance subdivision surface (subdiv) evaluation on massively
 parallel CPU and GPU architectures. This codepath is optimized for
 drawing deforming subdivs with static topology at interactive
 framerates. The resulting limit surface matches Pixar's Renderman to
 numerical precision.
 .
 This package provides the GPU-based runtime library.

Package: libosd-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libosdcpu3.4.3 (= ${binary:Version}),
 libosdgpu3.4.3 (= ${binary:Version}),
 ${misc:Depends}
Description: high performance subdivision surface (subdiv) library - development
 OpenSubdiv is a set of open source libraries that implement high
 performance subdivision surface (subdiv) evaluation on massively
 parallel CPU and GPU architectures. This codepath is optimized for
 drawing deforming subdivs with static topology at interactive
 framerates. The resulting limit surface matches Pixar's Renderman to
 numerical precision.
 .
 This package provides the development files.

Package: libosd-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libosd-dev (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: high performance subdivision surface (subdiv) library - documentation
 OpenSubdiv is a set of open source libraries that implement high
 performance subdivision surface (subdiv) evaluation on massively
 parallel CPU and GPU architectures. This codepath is optimized for
 drawing deforming subdivs with static topology at interactive
 framerates. The resulting limit surface matches Pixar's Renderman to
 numerical precision.
 .
 This package provides the documentation.

Package: opensubdiv-tools
Section: graphics
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: high performance subdivision surface (subdiv) library - tools
 OpenSubdiv is a set of open source libraries that implement high
 performance subdivision surface (subdiv) evaluation on massively
 parallel CPU and GPU architectures. This codepath is optimized for
 drawing deforming subdivs with static topology at interactive
 framerates. The resulting limit surface matches Pixar's Renderman to
 numerical precision.
 .
 This package provides the official tools.
